::cisco::eem::event_register_timer watchdog name Policy_name time 10 queue_priority low nice 1 maxrun 0

namespace import ::cisco::eem::*
namespace import ::cisco::lib::*

# ==============================================================================
#
# version--date: 23May12
# simple_mutex.tcl by:	Joe Quinn, Davra Networks
# title:    Simple script mutex
# name:     simple_mutex.tcl
#
# Requires EEM 3.0 or higher
# This script can be used to ensure no 2 instances of the same script are running.
# If a script can possibly take a while to run and another instance of the same script runs in the meantime
# they will take up multiple threads, when no threads are free the EEM queue backs up, when the EEM queue is full, events start getting dropped.
#
# For EEM 2.4 and below you can use a lock file as a mutex but for 3.0 and above this approach is recommended as there is no reliance on a file external
# to the policy and lock files can be unreliable if they are deleted. Also you have to ensure you clean up lock files on restarts and re-registering the policy.
#
# To use this just copy the code snippet below into the top of your script change "Policy_name" to the name of your policy
#

if [catch {cli_open} result] { error $result $errorInfo } else { array set cli $result }
if [catch {cli_exec $cli(fd) "en"} result] { error $result $errorInfo }
if [catch {cli_exec $cli(fd) "sh ev m scheduler thread queue-type script detailed | incl Policy_name.tcl"} result] { error $result $errorInfo }
cli_close $cli(fd) $cli(tty_id)
set instanceCount [regexp -all ***=Policy_name $result]
if { $instanceCount >= 2 } {
    exit 0
}
